<html>
<head>
<title>OgreProperty.h Source File - OGRE Documentation</title> <meta http-equiv="Content-Type" content="text/html; charset=iso-8859-1"> 
<link type="text/css" rel="stylesheet" href="doxygen.css">
<link type="text/css" rel="stylesheet" href="tabs.css">
</head>

<body>
<!-- Generated by Doxygen 1.7.6.1 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.html"><span>Main&#160;Page</span></a></li>
      <li><a href="pages.html"><span>Related&#160;Pages</span></a></li>
      <li><a href="modules.html"><span>Modules</span></a></li>
      <li><a href="namespaces.html"><span>Namespaces</span></a></li>
      <li><a href="annotated.html"><span>Classes</span></a></li>
      <li class="current"><a href="files.html"><span>Files</span></a></li>
      <li><a href="dirs.html"><span>Directories</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.html"><span>File&#160;List</span></a></li>
      <li><a href="globals.html"><span>File&#160;Members</span></a></li>
    </ul>
  </div>
  <div id="nav-path" class="navpath">
    <ul>
      <li class="navelem"><a class="el" href="dir_f1fa7196649e3987904dbdb4948bc856.html">Components</a>      </li>
      <li class="navelem"><a class="el" href="dir_cfdec9b8cd4bd9d1a2493871fd6a0800.html">Property</a>      </li>
      <li class="navelem"><a class="el" href="dir_5a0563895dd4de2ce87b15d062de6bcd.html">include</a>      </li>
    </ul>
  </div>
</div>
<div class="header">
  <div class="headertitle">
<div class="title">OgreProperty.h</div>  </div>
</div><!--header-->
<div class="contents">
<a href="OgreProperty_8h.html">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">/*</span>
<a name="l00002"></a>00002 <span class="comment">-----------------------------------------------------------------------------</span>
<a name="l00003"></a>00003 <span class="comment">This source file is part of OGRE</span>
<a name="l00004"></a>00004 <span class="comment">(Object-oriented Graphics Rendering Engine)</span>
<a name="l00005"></a>00005 <span class="comment">For the latest info, see http://www.ogre3d.org/</span>
<a name="l00006"></a>00006 <span class="comment"></span>
<a name="l00007"></a>00007 <span class="comment">Copyright (c) 2000-2012 Torus Knot Software Ltd</span>
<a name="l00008"></a>00008 <span class="comment"></span>
<a name="l00009"></a>00009 <span class="comment">Permission is hereby granted, free of charge, to any person obtaining a copy</span>
<a name="l00010"></a>00010 <span class="comment">of this software and associated documentation files (the &quot;Software&quot;), to deal</span>
<a name="l00011"></a>00011 <span class="comment">in the Software without restriction, including without limitation the rights</span>
<a name="l00012"></a>00012 <span class="comment">to use, copy, modify, merge, publish, distribute, sublicense, and/or sell</span>
<a name="l00013"></a>00013 <span class="comment">copies of the Software, and to permit persons to whom the Software is</span>
<a name="l00014"></a>00014 <span class="comment">furnished to do so, subject to the following conditions:</span>
<a name="l00015"></a>00015 <span class="comment"></span>
<a name="l00016"></a>00016 <span class="comment">The above copyright notice and this permission notice shall be included in</span>
<a name="l00017"></a>00017 <span class="comment">all copies or substantial portions of the Software.</span>
<a name="l00018"></a>00018 <span class="comment"></span>
<a name="l00019"></a>00019 <span class="comment">THE SOFTWARE IS PROVIDED &quot;AS IS&quot;, WITHOUT WARRANTY OF ANY KIND, EXPRESS OR</span>
<a name="l00020"></a>00020 <span class="comment">IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,</span>
<a name="l00021"></a>00021 <span class="comment">FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE</span>
<a name="l00022"></a>00022 <span class="comment">AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER</span>
<a name="l00023"></a>00023 <span class="comment">LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,</span>
<a name="l00024"></a>00024 <span class="comment">OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN</span>
<a name="l00025"></a>00025 <span class="comment">THE SOFTWARE.</span>
<a name="l00026"></a>00026 <span class="comment">-----------------------------------------------------------------------------</span>
<a name="l00027"></a>00027 <span class="comment">*/</span>
<a name="l00028"></a>00028 <span class="preprocessor">#ifndef __OGRE_PROPERTY_H__</span>
<a name="l00029"></a>00029 <span class="preprocessor"></span><span class="preprocessor">#define __OGRE_PROPERTY_H__</span>
<a name="l00030"></a>00030 <span class="preprocessor"></span>
<a name="l00031"></a>00031 <span class="preprocessor">#include &quot;<a class="code" href="OgrePropertyPrerequisites_8h.html">OgrePropertyPrerequisites.h</a>&quot;</span>
<a name="l00032"></a>00032 <span class="preprocessor">#include &quot;<a class="code" href="OgreAny_8h.html">OgreAny.h</a>&quot;</span>
<a name="l00033"></a>00033 <span class="preprocessor">#include &quot;<a class="code" href="OgreIteratorWrappers_8h.html">OgreIteratorWrappers.h</a>&quot;</span>
<a name="l00034"></a>00034 <span class="preprocessor">#include &quot;<a class="code" href="OgreString_8h.html">OgreString.h</a>&quot;</span>
<a name="l00035"></a>00035 <span class="preprocessor">#include &quot;<a class="code" href="OgreException_8h.html">OgreException.h</a>&quot;</span>
<a name="l00036"></a>00036 <span class="preprocessor">#include &quot;<a class="code" href="OgreVector2_8h.html">OgreVector2.h</a>&quot;</span>
<a name="l00037"></a>00037 <span class="preprocessor">#include &quot;<a class="code" href="OgreVector3_8h.html">OgreVector3.h</a>&quot;</span>
<a name="l00038"></a>00038 <span class="preprocessor">#include &quot;<a class="code" href="OgreVector4_8h.html">OgreVector4.h</a>&quot;</span>
<a name="l00039"></a>00039 <span class="preprocessor">#include &quot;<a class="code" href="OgreColourValue_8h.html">OgreColourValue.h</a>&quot;</span>
<a name="l00040"></a>00040 <span class="preprocessor">#include &quot;<a class="code" href="OgreQuaternion_8h.html">OgreQuaternion.h</a>&quot;</span>
<a name="l00041"></a>00041 <span class="preprocessor">#include &quot;<a class="code" href="OgreMatrix3_8h.html">OgreMatrix3.h</a>&quot;</span>
<a name="l00042"></a>00042 <span class="preprocessor">#include &quot;<a class="code" href="OgreMatrix4_8h.html">OgreMatrix4.h</a>&quot;</span>
<a name="l00043"></a>00043 
<a name="l00044"></a>00044 <span class="preprocessor">#include &lt;boost/bind.hpp&gt;</span>
<a name="l00045"></a>00045 <span class="preprocessor">#include &lt;boost/function.hpp&gt;</span>
<a name="l00100"></a>00100 <span class="keyword">namespace </span>Ogre
<a name="l00101"></a>00101 {
<a name="l00109"></a>00109 
<a name="l00110"></a><a class="code" href="group__Property.html#ga0883a5af9197151407965df0bacc4f3a">00110</a>     <span class="keyword">enum</span> <a class="code" href="group__Property.html#ga0883a5af9197151407965df0bacc4f3a" title="The type of a property.">PropertyType</a>
<a name="l00111"></a>00111     {
<a name="l00112"></a><a class="code" href="group__Property.html#gga0883a5af9197151407965df0bacc4f3aa19d90ad1680589279aafec448c4e75d3">00112</a>         <a class="code" href="group__Property.html#gga0883a5af9197151407965df0bacc4f3aa19d90ad1680589279aafec448c4e75d3">PROP_SHORT</a> = 0,
<a name="l00113"></a><a class="code" href="group__Property.html#gga0883a5af9197151407965df0bacc4f3aa8807d302197c648340522a66196f46f1">00113</a>         <a class="code" href="group__Property.html#gga0883a5af9197151407965df0bacc4f3aa8807d302197c648340522a66196f46f1">PROP_UNSIGNED_SHORT</a> = 1,
<a name="l00114"></a><a class="code" href="group__Property.html#gga0883a5af9197151407965df0bacc4f3aa93d4b54300df506764ebb8af6bf4d5c8">00114</a>         <a class="code" href="group__Property.html#gga0883a5af9197151407965df0bacc4f3aa93d4b54300df506764ebb8af6bf4d5c8">PROP_INT</a> = 2,
<a name="l00115"></a><a class="code" href="group__Property.html#gga0883a5af9197151407965df0bacc4f3aa9fb3644ad2ce148f77291a0d3eaea6a1">00115</a>         <a class="code" href="group__Property.html#gga0883a5af9197151407965df0bacc4f3aa9fb3644ad2ce148f77291a0d3eaea6a1">PROP_UNSIGNED_INT</a> = 3,
<a name="l00116"></a><a class="code" href="group__Property.html#gga0883a5af9197151407965df0bacc4f3aa3d3a41849ca836ff178c8f2618629794">00116</a>         <a class="code" href="group__Property.html#gga0883a5af9197151407965df0bacc4f3aa3d3a41849ca836ff178c8f2618629794">PROP_LONG</a> = 4, 
<a name="l00117"></a><a class="code" href="group__Property.html#gga0883a5af9197151407965df0bacc4f3aabb2c30d9d8af27d83d4aafed018aa84d">00117</a>         <a class="code" href="group__Property.html#gga0883a5af9197151407965df0bacc4f3aabb2c30d9d8af27d83d4aafed018aa84d">PROP_UNSIGNED_LONG</a> = 5,
<a name="l00118"></a><a class="code" href="group__Property.html#gga0883a5af9197151407965df0bacc4f3aa269350183053663ed0e36a69b72dc4c8">00118</a>         <a class="code" href="group__Property.html#gga0883a5af9197151407965df0bacc4f3aa269350183053663ed0e36a69b72dc4c8">PROP_REAL</a> = 6,
<a name="l00119"></a><a class="code" href="group__Property.html#gga0883a5af9197151407965df0bacc4f3aa7964244e71bea1a0b721d42e6fa4ae53">00119</a>         <a class="code" href="group__Property.html#gga0883a5af9197151407965df0bacc4f3aa7964244e71bea1a0b721d42e6fa4ae53">PROP_STRING</a> = 7,
<a name="l00120"></a><a class="code" href="group__Property.html#gga0883a5af9197151407965df0bacc4f3aa5f081dc286c25333c43e8467d6c7c8b6">00120</a>         <a class="code" href="group__Property.html#gga0883a5af9197151407965df0bacc4f3aa5f081dc286c25333c43e8467d6c7c8b6">PROP_VECTOR2</a> = 8, 
<a name="l00121"></a><a class="code" href="group__Property.html#gga0883a5af9197151407965df0bacc4f3aacd225d4bbfbd47f0473b7d56f834f3b6">00121</a>         <a class="code" href="group__Property.html#gga0883a5af9197151407965df0bacc4f3aacd225d4bbfbd47f0473b7d56f834f3b6">PROP_VECTOR3</a> = 9,
<a name="l00122"></a><a class="code" href="group__Property.html#gga0883a5af9197151407965df0bacc4f3aaa5b410ea31e3954eeba233240dfb67ec">00122</a>         <a class="code" href="group__Property.html#gga0883a5af9197151407965df0bacc4f3aaa5b410ea31e3954eeba233240dfb67ec">PROP_VECTOR4</a> = 10, 
<a name="l00123"></a><a class="code" href="group__Property.html#gga0883a5af9197151407965df0bacc4f3aa4dbf2ba96cd6b8774fc4cd98b0bfca01">00123</a>         <a class="code" href="group__Property.html#gga0883a5af9197151407965df0bacc4f3aa4dbf2ba96cd6b8774fc4cd98b0bfca01">PROP_COLOUR</a> = 11,
<a name="l00124"></a><a class="code" href="group__Property.html#gga0883a5af9197151407965df0bacc4f3aa4811d3c1f6bce61a13fedbcfa19e1b32">00124</a>         <a class="code" href="group__Property.html#gga0883a5af9197151407965df0bacc4f3aa4811d3c1f6bce61a13fedbcfa19e1b32">PROP_BOOL</a> = 12,
<a name="l00125"></a><a class="code" href="group__Property.html#gga0883a5af9197151407965df0bacc4f3aa161aabceab220d04e7aa8704ff8e5293">00125</a>         <a class="code" href="group__Property.html#gga0883a5af9197151407965df0bacc4f3aa161aabceab220d04e7aa8704ff8e5293">PROP_QUATERNION</a> = 13, 
<a name="l00126"></a><a class="code" href="group__Property.html#gga0883a5af9197151407965df0bacc4f3aa1a10d1f71eb0804ab6ec20a598a1ac93">00126</a>         <a class="code" href="group__Property.html#gga0883a5af9197151407965df0bacc4f3aa1a10d1f71eb0804ab6ec20a598a1ac93">PROP_MATRIX3</a> = 14,
<a name="l00127"></a><a class="code" href="group__Property.html#gga0883a5af9197151407965df0bacc4f3aad1ccdd4ffa8de819d5f96bac1a405a32">00127</a>         <a class="code" href="group__Property.html#gga0883a5af9197151407965df0bacc4f3aad1ccdd4ffa8de819d5f96bac1a405a32">PROP_MATRIX4</a> = 15, 
<a name="l00128"></a>00128 
<a name="l00129"></a><a class="code" href="group__Property.html#gga0883a5af9197151407965df0bacc4f3aa593a0408d46ccf3061cb27c372b25e8d">00129</a>         <a class="code" href="group__Property.html#gga0883a5af9197151407965df0bacc4f3aa593a0408d46ccf3061cb27c372b25e8d">PROP_UNKNOWN</a> = 999
<a name="l00130"></a>00130     };
<a name="l00131"></a>00131 
<a name="l00137"></a><a class="code" href="classOgre_1_1PropertyDef.html">00137</a>     <span class="keyword">class </span><a class="code" href="OgrePropertyPrerequisites_8h.html#af28d18a1b484acf19bec2841bc9ec96f">_OgrePropertyExport</a> <a class="code" href="classOgre_1_1PropertyDef.html" title="Definition of a property of an object.">PropertyDef</a> : <span class="keyword">public</span> <a class="code" href="classOgre_1_1AllocatedObject.html" title="Superclass for all objects that wish to use custom memory allocators when their new / delete operator...">PropertyAlloc</a>
<a name="l00138"></a>00138     {
<a name="l00139"></a>00139     <span class="keyword">public</span>:
<a name="l00140"></a>00140 
<a name="l00141"></a>00141         <span class="comment">/* Construct a property.</span>
<a name="l00142"></a>00142 <span class="comment">        @param name The name of the property</span>
<a name="l00143"></a>00143 <span class="comment">        @param desc A (potentially) long description of the property</span>
<a name="l00144"></a>00144 <span class="comment">        @param pType The type of the property</span>
<a name="l00145"></a>00145 <span class="comment">        */</span>
<a name="l00146"></a><a class="code" href="classOgre_1_1PropertyDef.html#a41cc7c20c02222c76f11d43489695551">00146</a>         <a class="code" href="classOgre_1_1PropertyDef.html" title="Definition of a property of an object.">PropertyDef</a>(<span class="keyword">const</span> <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp; name, <span class="keyword">const</span> <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp; desc, <a class="code" href="group__Property.html#ga0883a5af9197151407965df0bacc4f3a" title="The type of a property.">PropertyType</a> pType)
<a name="l00147"></a>00147             : mName(name), mDesc(desc), mType(pType) {}
<a name="l00148"></a>00148 
<a name="l00150"></a><a class="code" href="classOgre_1_1PropertyDef.html#aa9fbb3c56557f180a179dfe915388a5c">00150</a>         <span class="keyword">const</span> <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp; <a class="code" href="classOgre_1_1PropertyDef.html#aa9fbb3c56557f180a179dfe915388a5c" title="Get the name of the property.">getName</a>()<span class="keyword"> const </span>{ <span class="keywordflow">return</span> mName; }
<a name="l00151"></a>00151 
<a name="l00153"></a><a class="code" href="classOgre_1_1PropertyDef.html#a36af51365e6f5ef64b2875ffbe96a004">00153</a>         <span class="keyword">const</span> <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp; <a class="code" href="classOgre_1_1PropertyDef.html#a36af51365e6f5ef64b2875ffbe96a004" title="Get the description of the property.">getDescription</a>()<span class="keyword"> const </span>{ <span class="keywordflow">return</span> mDesc; }
<a name="l00154"></a>00154 
<a name="l00156"></a><a class="code" href="classOgre_1_1PropertyDef.html#a42127e0d5069c7b25c67eb53326536e0">00156</a>         <a class="code" href="group__Property.html#ga0883a5af9197151407965df0bacc4f3a" title="The type of a property.">PropertyType</a> <a class="code" href="classOgre_1_1PropertyDef.html#a42127e0d5069c7b25c67eb53326536e0" title="Get the type of the property.">getType</a>()<span class="keyword"> const </span>{ <span class="keywordflow">return</span> mType; }
<a name="l00157"></a>00157 
<a name="l00159"></a>00159         <span class="keyword">static</span> <span class="keyword">const</span> <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp; getTypeName(<a class="code" href="group__Property.html#ga0883a5af9197151407965df0bacc4f3a" title="The type of a property.">PropertyType</a> theType);
<a name="l00160"></a>00160 
<a name="l00161"></a><a class="code" href="classOgre_1_1PropertyDef.html#af1f43d6fa9c867fbbac7c847c2331a4a">00161</a>         <span class="keyword">static</span> <a class="code" href="group__Property.html#ga0883a5af9197151407965df0bacc4f3a" title="The type of a property.">PropertyType</a> <a class="code" href="classOgre_1_1PropertyDef.html#af1f43d6fa9c867fbbac7c847c2331a4a">getTypeForValue</a>(<span class="keyword">const</span> <span class="keywordtype">short</span>&amp; val) { <span class="keywordflow">return</span> <a class="code" href="group__Property.html#gga0883a5af9197151407965df0bacc4f3aa19d90ad1680589279aafec448c4e75d3">PROP_SHORT</a>; }
<a name="l00162"></a><a class="code" href="classOgre_1_1PropertyDef.html#a11706d14ed57ce015ad363550c8b4a35">00162</a>         <span class="keyword">static</span> <a class="code" href="group__Property.html#ga0883a5af9197151407965df0bacc4f3a" title="The type of a property.">PropertyType</a> <a class="code" href="classOgre_1_1PropertyDef.html#a11706d14ed57ce015ad363550c8b4a35">getTypeForValue</a>(<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">short</span>&amp; val) { <span class="keywordflow">return</span> <a class="code" href="group__Property.html#gga0883a5af9197151407965df0bacc4f3aa8807d302197c648340522a66196f46f1">PROP_UNSIGNED_SHORT</a>; }
<a name="l00163"></a><a class="code" href="classOgre_1_1PropertyDef.html#ac8d97b00ddd7991fd1c6d844fcea22b7">00163</a>         <span class="keyword">static</span> <a class="code" href="group__Property.html#ga0883a5af9197151407965df0bacc4f3a" title="The type of a property.">PropertyType</a> <a class="code" href="classOgre_1_1PropertyDef.html#ac8d97b00ddd7991fd1c6d844fcea22b7">getTypeForValue</a>(<span class="keyword">const</span> <span class="keywordtype">int</span>&amp; val) { <span class="keywordflow">return</span> <a class="code" href="group__Property.html#gga0883a5af9197151407965df0bacc4f3aa93d4b54300df506764ebb8af6bf4d5c8">PROP_INT</a>; }
<a name="l00164"></a><a class="code" href="classOgre_1_1PropertyDef.html#a2b47385bebe000ae74e7281b65f177db">00164</a>         <span class="keyword">static</span> <a class="code" href="group__Property.html#ga0883a5af9197151407965df0bacc4f3a" title="The type of a property.">PropertyType</a> <a class="code" href="classOgre_1_1PropertyDef.html#a2b47385bebe000ae74e7281b65f177db">getTypeForValue</a>(<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span>&amp; val) { <span class="keywordflow">return</span> <a class="code" href="group__Property.html#gga0883a5af9197151407965df0bacc4f3aa9fb3644ad2ce148f77291a0d3eaea6a1">PROP_UNSIGNED_INT</a>; }
<a name="l00165"></a><a class="code" href="classOgre_1_1PropertyDef.html#aee5018eebdb2bac0a74b16b983547fdb">00165</a>         <span class="keyword">static</span> <a class="code" href="group__Property.html#ga0883a5af9197151407965df0bacc4f3a" title="The type of a property.">PropertyType</a> <a class="code" href="classOgre_1_1PropertyDef.html#aee5018eebdb2bac0a74b16b983547fdb">getTypeForValue</a>(<span class="keyword">const</span> <span class="keywordtype">long</span>&amp; val) { <span class="keywordflow">return</span> <a class="code" href="group__Property.html#gga0883a5af9197151407965df0bacc4f3aa3d3a41849ca836ff178c8f2618629794">PROP_LONG</a>; }
<a name="l00166"></a><a class="code" href="classOgre_1_1PropertyDef.html#ad7e4b21a152c6f6657ce02a210b30b58">00166</a>         <span class="keyword">static</span> <a class="code" href="group__Property.html#ga0883a5af9197151407965df0bacc4f3a" title="The type of a property.">PropertyType</a> <a class="code" href="classOgre_1_1PropertyDef.html#ad7e4b21a152c6f6657ce02a210b30b58">getTypeForValue</a>(<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">long</span>&amp; val) { <span class="keywordflow">return</span> <a class="code" href="group__Property.html#gga0883a5af9197151407965df0bacc4f3aabb2c30d9d8af27d83d4aafed018aa84d">PROP_UNSIGNED_LONG</a>; }
<a name="l00167"></a><a class="code" href="classOgre_1_1PropertyDef.html#ab66019ead72453626dde1c5529392e79">00167</a>         <span class="keyword">static</span> <a class="code" href="group__Property.html#ga0883a5af9197151407965df0bacc4f3a" title="The type of a property.">PropertyType</a> <a class="code" href="classOgre_1_1PropertyDef.html#ab66019ead72453626dde1c5529392e79">getTypeForValue</a>(<span class="keyword">const</span> <a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a>&amp; val) { <span class="keywordflow">return</span> <a class="code" href="group__Property.html#gga0883a5af9197151407965df0bacc4f3aa269350183053663ed0e36a69b72dc4c8">PROP_REAL</a>; }
<a name="l00168"></a><a class="code" href="classOgre_1_1PropertyDef.html#a4085561ce2c745b94f24163f05f77a85">00168</a>         <span class="keyword">static</span> <a class="code" href="group__Property.html#ga0883a5af9197151407965df0bacc4f3a" title="The type of a property.">PropertyType</a> <a class="code" href="classOgre_1_1PropertyDef.html#a4085561ce2c745b94f24163f05f77a85">getTypeForValue</a>(<span class="keyword">const</span> <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp; val) { <span class="keywordflow">return</span> <a class="code" href="group__Property.html#gga0883a5af9197151407965df0bacc4f3aa7964244e71bea1a0b721d42e6fa4ae53">PROP_STRING</a>; }
<a name="l00169"></a><a class="code" href="classOgre_1_1PropertyDef.html#a9a6f217f142938d7035f4b0507430fa2">00169</a>         <span class="keyword">static</span> <a class="code" href="group__Property.html#ga0883a5af9197151407965df0bacc4f3a" title="The type of a property.">PropertyType</a> <a class="code" href="classOgre_1_1PropertyDef.html#a9a6f217f142938d7035f4b0507430fa2">getTypeForValue</a>(<span class="keyword">const</span> <a class="code" href="classOgre_1_1Vector2.html" title="Standard 2-dimensional vector.">Vector2</a>&amp; val) { <span class="keywordflow">return</span> <a class="code" href="group__Property.html#gga0883a5af9197151407965df0bacc4f3aa5f081dc286c25333c43e8467d6c7c8b6">PROP_VECTOR2</a>; }
<a name="l00170"></a><a class="code" href="classOgre_1_1PropertyDef.html#a94debb259e471f515823736dec0ff488">00170</a>         <span class="keyword">static</span> <a class="code" href="group__Property.html#ga0883a5af9197151407965df0bacc4f3a" title="The type of a property.">PropertyType</a> <a class="code" href="classOgre_1_1PropertyDef.html#a94debb259e471f515823736dec0ff488">getTypeForValue</a>(<span class="keyword">const</span> <a class="code" href="classOgre_1_1Vector3.html" title="Standard 3-dimensional vector.">Vector3</a>&amp; val) { <span class="keywordflow">return</span> <a class="code" href="group__Property.html#gga0883a5af9197151407965df0bacc4f3aacd225d4bbfbd47f0473b7d56f834f3b6">PROP_VECTOR3</a>; }
<a name="l00171"></a><a class="code" href="classOgre_1_1PropertyDef.html#a07dab739e1465c57f8f287aa3d8a18ae">00171</a>         <span class="keyword">static</span> <a class="code" href="group__Property.html#ga0883a5af9197151407965df0bacc4f3a" title="The type of a property.">PropertyType</a> <a class="code" href="classOgre_1_1PropertyDef.html#a07dab739e1465c57f8f287aa3d8a18ae">getTypeForValue</a>(<span class="keyword">const</span> <a class="code" href="classOgre_1_1Vector4.html" title="4-dimensional homogeneous vector.">Vector4</a>&amp; val) { <span class="keywordflow">return</span> <a class="code" href="group__Property.html#gga0883a5af9197151407965df0bacc4f3aaa5b410ea31e3954eeba233240dfb67ec">PROP_VECTOR4</a>; }
<a name="l00172"></a><a class="code" href="classOgre_1_1PropertyDef.html#a26efb3b5354c5fa5bcf630cc97847fdf">00172</a>         <span class="keyword">static</span> <a class="code" href="group__Property.html#ga0883a5af9197151407965df0bacc4f3a" title="The type of a property.">PropertyType</a> <a class="code" href="classOgre_1_1PropertyDef.html#a26efb3b5354c5fa5bcf630cc97847fdf">getTypeForValue</a>(<span class="keyword">const</span> <a class="code" href="classOgre_1_1ColourValue.html" title="Class representing colour.">ColourValue</a>&amp; val) { <span class="keywordflow">return</span> <a class="code" href="group__Property.html#gga0883a5af9197151407965df0bacc4f3aa4dbf2ba96cd6b8774fc4cd98b0bfca01">PROP_COLOUR</a>; }
<a name="l00173"></a><a class="code" href="classOgre_1_1PropertyDef.html#a2e28520f52bd076d73becb579949c821">00173</a>         <span class="keyword">static</span> <a class="code" href="group__Property.html#ga0883a5af9197151407965df0bacc4f3a" title="The type of a property.">PropertyType</a> <a class="code" href="classOgre_1_1PropertyDef.html#a2e28520f52bd076d73becb579949c821">getTypeForValue</a>(<span class="keyword">const</span> <span class="keywordtype">bool</span>&amp; val) { <span class="keywordflow">return</span> <a class="code" href="group__Property.html#gga0883a5af9197151407965df0bacc4f3aa4811d3c1f6bce61a13fedbcfa19e1b32">PROP_BOOL</a>; }
<a name="l00174"></a><a class="code" href="classOgre_1_1PropertyDef.html#a12b0236db01a784799530942a8f50d82">00174</a>         <span class="keyword">static</span> <a class="code" href="group__Property.html#ga0883a5af9197151407965df0bacc4f3a" title="The type of a property.">PropertyType</a> <a class="code" href="classOgre_1_1PropertyDef.html#a12b0236db01a784799530942a8f50d82">getTypeForValue</a>(<span class="keyword">const</span> <a class="code" href="classOgre_1_1Quaternion.html" title="Implementation of a Quaternion, i.e.">Quaternion</a>&amp; val) { <span class="keywordflow">return</span> <a class="code" href="group__Property.html#gga0883a5af9197151407965df0bacc4f3aa161aabceab220d04e7aa8704ff8e5293">PROP_QUATERNION</a>; }
<a name="l00175"></a><a class="code" href="classOgre_1_1PropertyDef.html#a883ccd53919be65e73d2524fd5ea598c">00175</a>         <span class="keyword">static</span> <a class="code" href="group__Property.html#ga0883a5af9197151407965df0bacc4f3a" title="The type of a property.">PropertyType</a> <a class="code" href="classOgre_1_1PropertyDef.html#a883ccd53919be65e73d2524fd5ea598c">getTypeForValue</a>(<span class="keyword">const</span> <a class="code" href="classOgre_1_1Matrix3.html" title="A 3x3 matrix which can represent rotations around axes.">Matrix3</a>&amp; val) { <span class="keywordflow">return</span> <a class="code" href="group__Property.html#gga0883a5af9197151407965df0bacc4f3aa1a10d1f71eb0804ab6ec20a598a1ac93">PROP_MATRIX3</a>; }
<a name="l00176"></a><a class="code" href="classOgre_1_1PropertyDef.html#aa3f812514090432149116f4dc278e70c">00176</a>         <span class="keyword">static</span> <a class="code" href="group__Property.html#ga0883a5af9197151407965df0bacc4f3a" title="The type of a property.">PropertyType</a> <a class="code" href="classOgre_1_1PropertyDef.html#aa3f812514090432149116f4dc278e70c">getTypeForValue</a>(<span class="keyword">const</span> <a class="code" href="classOgre_1_1Matrix4.html" title="Class encapsulating a standard 4x4 homogeneous matrix.">Matrix4</a>&amp; val) { <span class="keywordflow">return</span> <a class="code" href="group__Property.html#gga0883a5af9197151407965df0bacc4f3aad1ccdd4ffa8de819d5f96bac1a405a32">PROP_MATRIX4</a>; }
<a name="l00177"></a>00177 
<a name="l00178"></a>00178     <span class="keyword">protected</span>:
<a name="l00179"></a>00179         <span class="comment">// no default construction</span>
<a name="l00180"></a><a class="code" href="classOgre_1_1PropertyDef.html#a3cc6b402707f944ae9bb426f8161b340">00180</a>         <a class="code" href="classOgre_1_1PropertyDef.html#a3cc6b402707f944ae9bb426f8161b340">PropertyDef</a>() {}
<a name="l00181"></a>00181 
<a name="l00182"></a><a class="code" href="classOgre_1_1PropertyDef.html#a575daff2df886d3d4e4c6c7ce0b34654">00182</a>         <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a> <a class="code" href="classOgre_1_1PropertyDef.html#a575daff2df886d3d4e4c6c7ce0b34654">mName</a>;
<a name="l00183"></a><a class="code" href="classOgre_1_1PropertyDef.html#a32aeb4f20db1bd6317d2d02b356ae819">00183</a>         <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a> <a class="code" href="classOgre_1_1PropertyDef.html#a32aeb4f20db1bd6317d2d02b356ae819">mDesc</a>;
<a name="l00184"></a><a class="code" href="classOgre_1_1PropertyDef.html#a8b61c74092cf7b920777716459c5953c">00184</a>         <a class="code" href="group__Property.html#ga0883a5af9197151407965df0bacc4f3a" title="The type of a property.">PropertyType</a> <a class="code" href="classOgre_1_1PropertyDef.html#a8b61c74092cf7b920777716459c5953c">mType</a>;
<a name="l00185"></a>00185 
<a name="l00186"></a>00186     };
<a name="l00187"></a>00187 
<a name="l00189"></a><a class="code" href="group__Property.html#gaa2af9dd0402adef0e54243e3ee3dc86e">00189</a>     <span class="keyword">typedef</span> <a class="code" href="structOgre_1_1map.html#a1e455b5b9d3d4a7d72c71a0b5d9e21ae">map&lt;String, PropertyDef&gt;::type</a> <a class="code" href="group__Property.html#gaa2af9dd0402adef0e54243e3ee3dc86e" title="Map from property name to shared definition.">PropertyDefMap</a>;
<a name="l00190"></a>00190 
<a name="l00193"></a><a class="code" href="classOgre_1_1PropertyBase.html">00193</a>     <span class="keyword">class </span><a class="code" href="OgrePropertyPrerequisites_8h.html#af28d18a1b484acf19bec2841bc9ec96f">_OgrePropertyExport</a> <a class="code" href="classOgre_1_1PropertyBase.html" title="Base interface for an instance of a property.">PropertyBase</a> : <span class="keyword">public</span> <a class="code" href="classOgre_1_1AllocatedObject.html" title="Superclass for all objects that wish to use custom memory allocators when their new / delete operator...">PropertyAlloc</a>
<a name="l00194"></a>00194     {
<a name="l00195"></a>00195     <span class="keyword">public</span>:
<a name="l00197"></a><a class="code" href="classOgre_1_1PropertyBase.html#ad5871ff3ceefd077a141e36362eaabf1">00197</a>         <a class="code" href="classOgre_1_1PropertyBase.html#ad5871ff3ceefd077a141e36362eaabf1" title="Constructor.">PropertyBase</a>(<a class="code" href="classOgre_1_1PropertyDef.html" title="Definition of a property of an object.">PropertyDef</a>* def) : mDef(def) {}
<a name="l00198"></a><a class="code" href="classOgre_1_1PropertyBase.html#ab7f1338b4246c1650dd4e4b864831f9f">00198</a>         <span class="keyword">virtual</span> <a class="code" href="classOgre_1_1PropertyBase.html#ab7f1338b4246c1650dd4e4b864831f9f">~PropertyBase</a>() {}
<a name="l00199"></a>00199 
<a name="l00201"></a><a class="code" href="classOgre_1_1PropertyBase.html#ae5c34f2439e75d64546c6ba66aaa416c">00201</a>         <span class="keyword">const</span> <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp; <a class="code" href="classOgre_1_1PropertyBase.html#ae5c34f2439e75d64546c6ba66aaa416c" title="Get the name of the property.">getName</a>()<span class="keyword"> const </span>{ <span class="keywordflow">return</span> mDef-&gt;getName(); }
<a name="l00202"></a>00202 
<a name="l00204"></a><a class="code" href="classOgre_1_1PropertyBase.html#ae52234c3944af11a8f40ec4126d8814d">00204</a>         <span class="keyword">const</span> <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp; <a class="code" href="classOgre_1_1PropertyBase.html#ae52234c3944af11a8f40ec4126d8814d" title="Get the description of the property.">getDescription</a>()<span class="keyword"> const </span>{ <span class="keywordflow">return</span> mDef-&gt;getDescription(); }
<a name="l00205"></a>00205 
<a name="l00207"></a><a class="code" href="classOgre_1_1PropertyBase.html#af795a97a18ea3c9e3b22004279a5fd63">00207</a>         <a class="code" href="group__Property.html#ga0883a5af9197151407965df0bacc4f3a" title="The type of a property.">PropertyType</a> <a class="code" href="classOgre_1_1PropertyBase.html#af795a97a18ea3c9e3b22004279a5fd63" title="Get the type of the property.">getType</a>()<span class="keyword"> const </span>{ <span class="keywordflow">return</span> mDef-&gt;getType(); }
<a name="l00208"></a>00208 
<a name="l00210"></a>00210         <span class="keyword">virtual</span> <a class="code" href="classOgre_1_1Any.html" title="Variant type that can hold Any other type.">Ogre::Any</a> getValue() <span class="keyword">const</span> = 0;
<a name="l00211"></a>00211 
<a name="l00212"></a>00212     <span class="keyword">protected</span>:
<a name="l00213"></a>00213         <span class="comment">// disallow default construction</span>
<a name="l00214"></a><a class="code" href="classOgre_1_1PropertyBase.html#ad7d29d8ad234e4b60a533bca023aa750">00214</a>         <a class="code" href="classOgre_1_1PropertyBase.html#ad7d29d8ad234e4b60a533bca023aa750">PropertyBase</a>() {}
<a name="l00215"></a><a class="code" href="classOgre_1_1PropertyBase.html#a5aabbce3c4a0808e6d0902cf4c7686f6">00215</a>         <a class="code" href="classOgre_1_1PropertyDef.html" title="Definition of a property of an object.">PropertyDef</a>* <a class="code" href="classOgre_1_1PropertyBase.html#a5aabbce3c4a0808e6d0902cf4c7686f6">mDef</a>;
<a name="l00216"></a>00216 
<a name="l00217"></a>00217     };
<a name="l00218"></a>00218 
<a name="l00220"></a>00220     <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00221"></a><a class="code" href="classOgre_1_1Property.html">00221</a>     <span class="keyword">class </span><a class="code" href="classOgre_1_1Property.html" title="Property instance with passthrough calls to a given object.">Property</a> : <span class="keyword">public</span> <a class="code" href="classOgre_1_1PropertyBase.html" title="Base interface for an instance of a property.">PropertyBase</a>
<a name="l00222"></a>00222     {
<a name="l00223"></a>00223     <span class="keyword">public</span>:
<a name="l00224"></a><a class="code" href="classOgre_1_1Property.html#a06f442becff5384a8fd99c21eeb0234b">00224</a>         <span class="keyword">typedef</span> T <a class="code" href="classOgre_1_1Property.html#a06f442becff5384a8fd99c21eeb0234b">value_type</a>;
<a name="l00225"></a><a class="code" href="classOgre_1_1Property.html#aad6a9bb90d4c502d392dc93a2b5c6d9e">00225</a>         <span class="keyword">typedef</span> boost::function&lt; T (void) &gt; <a class="code" href="classOgre_1_1Property.html#aad6a9bb90d4c502d392dc93a2b5c6d9e">getter_func</a>;
<a name="l00226"></a><a class="code" href="classOgre_1_1Property.html#a17a075b8283c837859cd72c546b674ce">00226</a>         <span class="keyword">typedef</span> boost::function&lt; void (T) &gt; <a class="code" href="classOgre_1_1Property.html#a17a075b8283c837859cd72c546b674ce">setter_func</a>;
<a name="l00227"></a>00227 
<a name="l00231"></a><a class="code" href="classOgre_1_1Property.html#a12487350ad5d420e7c607551da33bb2c">00231</a>         <a class="code" href="classOgre_1_1Property.html#a41b0d8f1c3e2c0538adeb60fff181e34">Property</a>(<a class="code" href="classOgre_1_1PropertyDef.html" title="Definition of a property of an object.">PropertyDef</a>* def, <a class="code" href="classOgre_1_1Property.html#aad6a9bb90d4c502d392dc93a2b5c6d9e">getter_func</a> getter, <a class="code" href="classOgre_1_1Property.html#a17a075b8283c837859cd72c546b674ce">setter_func</a> setter)
<a name="l00232"></a>00232             : <a class="code" href="classOgre_1_1PropertyBase.html" title="Base interface for an instance of a property.">PropertyBase</a>(def)
<a name="l00233"></a>00233             , <a class="code" href="classOgre_1_1Property.html#acba9ae82f6feea4ec62799c185e93bd5">mGetter</a>(getter)
<a name="l00234"></a>00234             , <a class="code" href="classOgre_1_1Property.html#a2748617917194872a3cd1594effb7047">mSetter</a>(setter) 
<a name="l00235"></a>00235         {
<a name="l00236"></a>00236         }
<a name="l00237"></a>00237 
<a name="l00240"></a><a class="code" href="classOgre_1_1Property.html#aca2854fc3ea2b44d61082613cb4acd4c">00240</a>         <span class="keyword">virtual</span> <span class="keywordtype">void</span> <span class="keyword">set</span>(T val)
<a name="l00241"></a>00241         {
<a name="l00242"></a>00242             <a class="code" href="classOgre_1_1Property.html#a2748617917194872a3cd1594effb7047">mSetter</a>(val);
<a name="l00243"></a>00243         }
<a name="l00244"></a>00244 
<a name="l00245"></a><a class="code" href="classOgre_1_1Property.html#a817d8391972da5f77459166a377c4e83">00245</a>         <span class="keyword">virtual</span> T <span class="keyword">get</span>() <span class="keyword">const</span>
<a name="l00246"></a>00246         {
<a name="l00247"></a>00247             <span class="keywordflow">return</span> <a class="code" href="classOgre_1_1Property.html#acba9ae82f6feea4ec62799c185e93bd5">mGetter</a>();
<a name="l00248"></a>00248         }
<a name="l00249"></a>00249 
<a name="l00250"></a><a class="code" href="classOgre_1_1Property.html#a16d614717440139e615fd9f43e0ad402">00250</a>         <a class="code" href="classOgre_1_1Any.html" title="Variant type that can hold Any other type.">Ogre::Any</a> <a class="code" href="classOgre_1_1Property.html#a16d614717440139e615fd9f43e0ad402" title="Return the current value as an Any.">getValue</a>()<span class="keyword"> const</span>
<a name="l00251"></a>00251 <span class="keyword">        </span>{
<a name="l00252"></a>00252             <span class="keywordflow">return</span> <a class="code" href="classOgre_1_1Any.html" title="Variant type that can hold Any other type.">Ogre::Any</a>(<span class="keyword">get</span>());
<a name="l00253"></a>00253         }
<a name="l00254"></a>00254 
<a name="l00255"></a>00255     <span class="keyword">protected</span>:
<a name="l00256"></a>00256         <span class="comment">// disallow default construction</span>
<a name="l00257"></a><a class="code" href="classOgre_1_1Property.html#a41b0d8f1c3e2c0538adeb60fff181e34">00257</a>         <a class="code" href="classOgre_1_1Property.html#a41b0d8f1c3e2c0538adeb60fff181e34">Property</a>() {}
<a name="l00258"></a><a class="code" href="classOgre_1_1Property.html#ac90105914dcb355dc46810aa71012e30">00258</a>         <a class="code" href="classOgre_1_1Property.html#ac90105914dcb355dc46810aa71012e30">~Property</a>() {}
<a name="l00259"></a>00259 
<a name="l00260"></a><a class="code" href="classOgre_1_1Property.html#acba9ae82f6feea4ec62799c185e93bd5">00260</a>         <a class="code" href="classOgre_1_1Property.html#aad6a9bb90d4c502d392dc93a2b5c6d9e">getter_func</a> <a class="code" href="classOgre_1_1Property.html#acba9ae82f6feea4ec62799c185e93bd5">mGetter</a>;
<a name="l00261"></a><a class="code" href="classOgre_1_1Property.html#a2748617917194872a3cd1594effb7047">00261</a>         <a class="code" href="classOgre_1_1Property.html#a17a075b8283c837859cd72c546b674ce">setter_func</a> <a class="code" href="classOgre_1_1Property.html#a2748617917194872a3cd1594effb7047">mSetter</a>;
<a name="l00262"></a>00262     };
<a name="l00263"></a>00263 
<a name="l00268"></a><a class="code" href="structOgre_1_1PropertyValue.html">00268</a>     <span class="keyword">struct </span><a class="code" href="structOgre_1_1PropertyValue.html" title="A simple structure designed just as a holder of property values between the instances of objects they...">PropertyValue</a>
<a name="l00269"></a>00269     {
<a name="l00270"></a><a class="code" href="structOgre_1_1PropertyValue.html#acba372a06626d7d2d0a6a232d0fdffbf">00270</a>         <a class="code" href="group__Property.html#ga0883a5af9197151407965df0bacc4f3a" title="The type of a property.">PropertyType</a> <a class="code" href="structOgre_1_1PropertyValue.html#acba372a06626d7d2d0a6a232d0fdffbf">propType</a>;
<a name="l00271"></a><a class="code" href="structOgre_1_1PropertyValue.html#a6b8054bd7cb64a2a21c22cd987c7885f">00271</a>         <a class="code" href="classOgre_1_1Any.html" title="Variant type that can hold Any other type.">Ogre::Any</a> <a class="code" href="structOgre_1_1PropertyValue.html#a6b8054bd7cb64a2a21c22cd987c7885f">val</a>;
<a name="l00272"></a>00272     };
<a name="l00274"></a><a class="code" href="group__Property.html#gac473fdb476888c7a1a0a4a857948cc5c">00274</a>     <span class="keyword">typedef</span> <a class="code" href="structOgre_1_1map.html#a1e455b5b9d3d4a7d72c71a0b5d9e21ae">map&lt;String, PropertyValue&gt;::type</a> <a class="code" href="group__Property.html#gac473fdb476888c7a1a0a4a857948cc5c" title="Defines a transferable map of properties using wrapped value types (Ogre::Any)">PropertyValueMap</a>;
<a name="l00275"></a>00275 
<a name="l00276"></a>00276 
<a name="l00279"></a><a class="code" href="classOgre_1_1PropertySet.html">00279</a>     <span class="keyword">class </span><a class="code" href="OgrePropertyPrerequisites_8h.html#af28d18a1b484acf19bec2841bc9ec96f">_OgrePropertyExport</a> <a class="code" href="classOgre_1_1PropertySet.html" title="Defines a complete set of properties for a single object instance.">PropertySet</a> : <span class="keyword">public</span> <a class="code" href="classOgre_1_1AllocatedObject.html" title="Superclass for all objects that wish to use custom memory allocators when their new / delete operator...">PropertyAlloc</a>
<a name="l00280"></a>00280     {
<a name="l00281"></a>00281     <span class="keyword">public</span>:
<a name="l00282"></a>00282         <a class="code" href="classOgre_1_1PropertySet.html" title="Defines a complete set of properties for a single object instance.">PropertySet</a>();
<a name="l00283"></a>00283         ~<a class="code" href="classOgre_1_1PropertySet.html" title="Defines a complete set of properties for a single object instance.">PropertySet</a>();
<a name="l00284"></a>00284 
<a name="l00289"></a>00289         <span class="keywordtype">void</span> addProperty(<a class="code" href="classOgre_1_1PropertyBase.html" title="Base interface for an instance of a property.">PropertyBase</a>* prop);
<a name="l00290"></a>00290 
<a name="l00298"></a>00298         <a class="code" href="classOgre_1_1PropertyBase.html" title="Base interface for an instance of a property.">PropertyBase</a>* getProperty(<span class="keyword">const</span> <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp; name) <span class="keyword">const</span>;
<a name="l00299"></a>00299 
<a name="l00301"></a>00301         <span class="keywordtype">bool</span> hasProperty(<span class="keyword">const</span> <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp; name) <span class="keyword">const</span>;
<a name="l00302"></a>00302 
<a name="l00304"></a>00304         <span class="keywordtype">void</span> removeProperty(<span class="keyword">const</span> <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp; name);
<a name="l00305"></a>00305 
<a name="l00306"></a><a class="code" href="classOgre_1_1PropertySet.html#a1db21116c18716df1bf043042e1e07c7">00306</a>         <span class="keyword">typedef</span> <a class="code" href="structOgre_1_1map.html">map&lt;String, PropertyBase*&gt;::type</a> <a class="code" href="classOgre_1_1PropertySet.html#a1db21116c18716df1bf043042e1e07c7">PropertyMap</a>;
<a name="l00307"></a><a class="code" href="classOgre_1_1PropertySet.html#a7f4ea40ca663fd32e4833801323033df">00307</a>         <span class="keyword">typedef</span> <a class="code" href="classOgre_1_1MapIterator.html" title="Concrete IteratorWrapper for nonconst access to the underlying key-value container.">Ogre::MapIterator&lt;PropertyMap&gt;</a> <a class="code" href="classOgre_1_1PropertySet.html#a7f4ea40ca663fd32e4833801323033df">PropertyIterator</a>;
<a name="l00309"></a>00309         <a class="code" href="classOgre_1_1MapIterator.html" title="Concrete IteratorWrapper for nonconst access to the underlying key-value container.">PropertyIterator</a> getPropertyIterator();
<a name="l00310"></a>00310 
<a name="l00314"></a>00314         <a class="code" href="group__Property.html#gac473fdb476888c7a1a0a4a857948cc5c" title="Defines a transferable map of properties using wrapped value types (Ogre::Any)">PropertyValueMap</a> getValueMap() <span class="keyword">const</span>;
<a name="l00315"></a>00315 
<a name="l00318"></a>00318         <span class="keywordtype">void</span> setValueMap(<span class="keyword">const</span> <a class="code" href="group__Property.html#gac473fdb476888c7a1a0a4a857948cc5c" title="Defines a transferable map of properties using wrapped value types (Ogre::Any)">PropertyValueMap</a>&amp; values);
<a name="l00319"></a>00319 
<a name="l00322"></a>00322         <span class="keyword">template</span>&lt;<span class="keyword">typename</span> T&gt;
<a name="l00323"></a><a class="code" href="classOgre_1_1PropertySet.html#aa19819ce458a54241ff460edc7bcda21">00323</a>         <span class="keywordtype">void</span> getValue(<span class="keyword">const</span> <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp; name, T&amp; value)<span class="keyword"> const</span>
<a name="l00324"></a>00324 <span class="keyword">        </span>{
<a name="l00325"></a>00325             getPropertyImpl(name, value, <a class="code" href="classOgre_1_1PropertyDef.html#af1f43d6fa9c867fbbac7c847c2331a4a">PropertyDef::getTypeForValue</a>(value));
<a name="l00326"></a>00326         }
<a name="l00327"></a>00327 
<a name="l00330"></a>00330         <span class="keyword">template</span>&lt;<span class="keyword">typename</span> T&gt;
<a name="l00331"></a><a class="code" href="classOgre_1_1PropertySet.html#ac5bbedd1543d61b98f23a102ddb3bc6a">00331</a>         <span class="keywordtype">void</span> setValue(<span class="keyword">const</span> <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp; name, <span class="keyword">const</span> T* value)
<a name="l00332"></a>00332         {
<a name="l00333"></a>00333             setPropertyImpl(name, *value, <a class="code" href="classOgre_1_1PropertyDef.html#af1f43d6fa9c867fbbac7c847c2331a4a">PropertyDef::getTypeForValue</a>(*value));
<a name="l00334"></a>00334         }
<a name="l00337"></a>00337         <span class="keyword">template</span>&lt;<span class="keyword">typename</span> T&gt;
<a name="l00338"></a><a class="code" href="classOgre_1_1PropertySet.html#a7dd1b0cfb09db83e1c4841136ff7f908">00338</a>         <span class="keywordtype">void</span> setValue(<span class="keyword">const</span> <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp; name, T value)
<a name="l00339"></a>00339         {
<a name="l00340"></a>00340             setPropertyImpl(name, value, <a class="code" href="classOgre_1_1PropertyDef.html#af1f43d6fa9c867fbbac7c847c2331a4a">PropertyDef::getTypeForValue</a>(value));
<a name="l00341"></a>00341         }
<a name="l00344"></a><a class="code" href="classOgre_1_1PropertySet.html#ae7a113c3e91c7c8e33087f5c4d0e750e">00344</a>         <span class="keywordtype">void</span> setValue(<span class="keyword">const</span> <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp; name, <span class="keyword">const</span> <span class="keywordtype">char</span>* pChar)
<a name="l00345"></a>00345         {
<a name="l00346"></a>00346             <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a> v(pChar);
<a name="l00347"></a>00347             setPropertyImpl(name, v, <a class="code" href="group__Property.html#gga0883a5af9197151407965df0bacc4f3aa7964244e71bea1a0b721d42e6fa4ae53">PROP_STRING</a>);
<a name="l00348"></a>00348         }
<a name="l00349"></a>00349 
<a name="l00350"></a>00350 
<a name="l00351"></a>00351     <span class="keyword">protected</span>:
<a name="l00352"></a><a class="code" href="classOgre_1_1PropertySet.html#ab11d302034431f15797e8dbb1a2e8de6">00352</a>         <a class="code" href="classOgre_1_1PropertySet.html#a1db21116c18716df1bf043042e1e07c7">PropertyMap</a> <a class="code" href="classOgre_1_1PropertySet.html#ab11d302034431f15797e8dbb1a2e8de6">mPropertyMap</a>;
<a name="l00353"></a>00353 
<a name="l00355"></a>00355         <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00356"></a><a class="code" href="classOgre_1_1PropertySet.html#a157fa940092747d4ed140a4842112305">00356</a>         <span class="keywordtype">void</span> setPropertyImpl(<span class="keyword">const</span> <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp; name, <span class="keyword">const</span> T&amp; val, <a class="code" href="group__Property.html#ga0883a5af9197151407965df0bacc4f3a" title="The type of a property.">PropertyType</a> typeCheck)
<a name="l00357"></a>00357         {
<a name="l00358"></a>00358             <a class="code" href="classOgre_1_1PropertyBase.html" title="Base interface for an instance of a property.">PropertyBase</a>* baseProp = getProperty(name);
<a name="l00359"></a>00359             <span class="keywordflow">if</span> (baseProp-&gt;<a class="code" href="classOgre_1_1PropertyBase.html#af795a97a18ea3c9e3b22004279a5fd63" title="Get the type of the property.">getType</a>() != typeCheck)
<a name="l00360"></a>00360             {
<a name="l00361"></a>00361                 <a class="code" href="classOgre_1_1StringUtil.html#a665d79932d54b48b83acff563de7a9e5">StringUtil::StrStreamType</a> msg;
<a name="l00362"></a>00362                 msg &lt;&lt; <span class="stringliteral">&quot;Property error: type passed in: &#39;&quot;</span> &lt;&lt; <a class="code" href="classOgre_1_1PropertyDef.html#a2b117f9bd3d234cf2df0facd2b698bb5" title="Get a string name of a property type.">PropertyDef::getTypeName</a>(typeCheck)
<a name="l00363"></a>00363                     &lt;&lt; <span class="stringliteral">&quot;&#39;, type of property: &#39;&quot;</span> &lt;&lt; <a class="code" href="classOgre_1_1PropertyDef.html#a2b117f9bd3d234cf2df0facd2b698bb5" title="Get a string name of a property type.">PropertyDef::getTypeName</a>(baseProp-&gt;<a class="code" href="classOgre_1_1PropertyBase.html#af795a97a18ea3c9e3b22004279a5fd63" title="Get the type of the property.">getType</a>()) &lt;&lt; <span class="stringliteral">&quot;&#39;&quot;</span>;
<a name="l00364"></a>00364                 OGRE_EXCEPT(<a class="code" href="classOgre_1_1Exception.html#a9bdf9b8a0a83b95818d676848beaa29ba359c10b8abe9abf39f84550a903e4698">Exception::ERR_INVALIDPARAMS</a>, msg.str(), <span class="stringliteral">&quot;PropertySet::setPropertyImpl&quot;</span>);
<a name="l00365"></a>00365             }
<a name="l00366"></a>00366             <span class="keyword">static_cast&lt;</span><a class="code" href="classOgre_1_1Property.html" title="Property instance with passthrough calls to a given object.">Property&lt;T&gt;</a>*<span class="keyword">&gt;</span>(baseProp)-&gt;<span class="keyword">set</span>(val);
<a name="l00367"></a>00367         }
<a name="l00368"></a>00368 
<a name="l00370"></a>00370         <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00371"></a><a class="code" href="classOgre_1_1PropertySet.html#ac49eb97615bc2c15528588d921b3667e">00371</a>         <span class="keywordtype">void</span> getPropertyImpl(<span class="keyword">const</span> <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp; name, T&amp; refVal, <a class="code" href="group__Property.html#ga0883a5af9197151407965df0bacc4f3a" title="The type of a property.">PropertyType</a> typeCheck)<span class="keyword"> const</span>
<a name="l00372"></a>00372 <span class="keyword">        </span>{
<a name="l00373"></a>00373             <a class="code" href="classOgre_1_1PropertyBase.html" title="Base interface for an instance of a property.">PropertyBase</a>* baseProp = getProperty(name);
<a name="l00374"></a>00374             <span class="keywordflow">if</span> (baseProp-&gt;<a class="code" href="classOgre_1_1PropertyBase.html#af795a97a18ea3c9e3b22004279a5fd63" title="Get the type of the property.">getType</a>() != typeCheck)
<a name="l00375"></a>00375             {
<a name="l00376"></a>00376                 <a class="code" href="classOgre_1_1StringUtil.html#a665d79932d54b48b83acff563de7a9e5">StringUtil::StrStreamType</a> msg;
<a name="l00377"></a>00377                 msg &lt;&lt; <span class="stringliteral">&quot;Property error: type requested: &#39;&quot;</span> &lt;&lt; <a class="code" href="classOgre_1_1PropertyDef.html#a2b117f9bd3d234cf2df0facd2b698bb5" title="Get a string name of a property type.">PropertyDef::getTypeName</a>(typeCheck)
<a name="l00378"></a>00378                     &lt;&lt; <span class="stringliteral">&quot;&#39;, type of property: &#39;&quot;</span> &lt;&lt; <a class="code" href="classOgre_1_1PropertyDef.html#a2b117f9bd3d234cf2df0facd2b698bb5" title="Get a string name of a property type.">PropertyDef::getTypeName</a>(baseProp-&gt;<a class="code" href="classOgre_1_1PropertyBase.html#af795a97a18ea3c9e3b22004279a5fd63" title="Get the type of the property.">getType</a>()) &lt;&lt; <span class="stringliteral">&quot;&#39;&quot;</span>;
<a name="l00379"></a>00379                 OGRE_EXCEPT(<a class="code" href="classOgre_1_1Exception.html#a9bdf9b8a0a83b95818d676848beaa29ba359c10b8abe9abf39f84550a903e4698">Exception::ERR_INVALIDPARAMS</a>, msg.str(), <span class="stringliteral">&quot;PropertySet::getPropertyImpl&quot;</span>);
<a name="l00380"></a>00380             }
<a name="l00381"></a>00381             refVal = <span class="keyword">static_cast&lt;</span><a class="code" href="classOgre_1_1Property.html" title="Property instance with passthrough calls to a given object.">Property&lt;T&gt;</a>*<span class="keyword">&gt;</span>(baseProp)-&gt;<span class="keyword">get</span>();
<a name="l00382"></a>00382         }
<a name="l00383"></a>00383 
<a name="l00384"></a>00384     };
<a name="l00385"></a>00385 
<a name="l00389"></a>00389 }
<a name="l00390"></a>00390 
<a name="l00391"></a>00391 <span class="preprocessor">#endif </span>
</pre></div></div><!-- contents -->
<hr>
<p>
Copyright &copy; 2012 Torus Knot Software Ltd<br />
<!--Creative Commons License--><a rel="license" href="http://creativecommons.org/licenses/by-sa/3.0/"><img alt="Creative Commons License" style="border-width:0" src="http://i.creativecommons.org/l/by-sa/3.0/88x31.png" /></a><br />This work is licensed under a <a rel="license" href="http://creativecommons.org/licenses/by-sa/3.0/">Creative Commons Attribution-ShareAlike 3.0 Unported License</a>.<br/>
		<!--/Creative Commons License--><!-- <rdf:RDF xmlns="http://web.resource.org/cc/" xmlns:dc="http://purl.org/dc/elements/1.1/" xmlns:rdf="http://www.w3.org/1999/02/22-rdf-syntax-ns#">
		<Work rdf:about="">
			<license rdf:resource="http://creativecommons.org/licenses/by-sa/2.5/" />
	<dc:type rdf:resource="http://purl.org/dc/dcmitype/Text" />
		</Work>
		<License rdf:about="http://creativecommons.org/licenses/by-sa/2.5/"><permits rdf:resource="http://web.resource.org/cc/Reproduction"/><permits rdf:resource="http://web.resource.org/cc/Distribution"/><requires rdf:resource="http://web.resource.org/cc/Notice"/><requires rdf:resource="http://web.resource.org/cc/Attribution"/><permits rdf:resource="http://web.resource.org/cc/DerivativeWorks"/><requires rdf:resource="http://web.resource.org/cc/ShareAlike"/></License></rdf:RDF> -->

Last modified Fri May 25 2012 21:48:51
</p>
</body>
</html>
